/*
 * INDEX.H - definitions for index package.
 *
 *                      Copyright (C) 1987, Jim Mischel
 * Modifications:
 *
 * 08/13/87 - jim - original coding
 */

/* field types for iopen() */
#define UCHAR   0x00
#define SCHAR   0x01
#define UINT    0x02
#define SINT    0x03
#define ULONG   0x04
#define SLONG   0x05
#define STRING  0x06
#define FLOAT   0x07
#define DOUBLE  0x08

/* conditions for istart() */
#define START_FILE        0
#define LT                1
#define LE                2
#define EQ                3
#define GE                4
#define GT                5
#define END_FILE          6

/* values returned in ierrno */
#define I_NODAT 0x10
#define I_DATRD 0x11
#define I_DATWT 0x12
#define I_NOINX 0x20
#define I_INXRD 0x21
#define I_INXWT 0x22
#define I_INVKEY 0x80
#define I_NOMEM 0x81
#define I_NOREC 0x82

/* global variables */
#ifdef __INDEX__
int ierrno;
#else
extern int ierrno;
#endif

/* user-callable routines */

void *iopen(char *fname, unsigned recsiz, char keytyp, unsigned offset,
            char dupflag, int (*cmp_rtn)());
void iclose(void *db_control);
int iread(void *db_control, void *destin);
int istart(void *db_control, char cond, void *source);
int iread_next(void *db_control, void *destin);
int iread_prev(void *db_control, void *destin);
int iwrite(void *db_control, void *source);
int irewrite(void *db_control, void *source);
int idelete(void *d, void *src);
